%global momorel 1

Summary: The basic directory layout for a Linux system
Name: filesystem
Version: 2.4.13
Release: %{momorel}m%{?dist}
License: Public Domain
Group: System Environment/Base
Buildroot: %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)
Source1: lang-exceptions
Requires(Pre): setup >= 2.5.4-1
BuildRequires: iso-codes

%description
The filesystem package is one of the basic packages that is installed
on a Linux system. Filesystem contains the basic directory layout
for a Linux operating system, including the correct permissions for
the directories.

%prep
rm -f $RPM_BUILD_DIR/filelist

%install
rm -rf %{buildroot}
mkdir %{buildroot}

cd %{buildroot}

mkdir -p mnt/{floppy,cdrom} \
	bin boot dev \
	etc/{X11/{applnk,fontpath.d},xdg/autostart,opt,xinetd.d,skel,sysconfig,pki,fonts/conf.d,news} \
	home lib/modules %{_lib}/tls media mnt opt proc root sbin selinux srv sys tmp \
        usr/{bin,etc,games,include,%{_lib}/{games,sse2,tls,X11},lib/{games,locale,X11},libexec,local/{bin,etc,games,lib,%{_lib},sbin,src,share/{applications,man/man{1,2,3,4,5,6,7,8,9,n,1x,2x,3x,4x,5x,6x,7x,8x,9x},info},libexec,include,},sbin,share/{applications,desktop-directories,dict,doc,empty,fonts,games,gnome,icons,info,man/man{1,2,3,4,5,6,7,8,9,n,1x,2x,3x,4x,5x,6x,7x,8x,9x,0p,1p,3p},mime-info,misc,omf,pixmaps,themes,xsessions,config-sample},src} \
        var/{empty,lib/{games,misc},local,lock/subsys,log,nis,preserve,run,spool/{mail,lpd},tmp,db,cache,opt,games,yp}

ln -snf ../var/tmp usr/tmp
ln -snf spool/mail var/mail

grep -v "^$" /usr/share/iso-codes/iso_639.tab | grep -v "^#" | while read a b c d ; do
	[[ "$d" =~ "^Reserved" ]] && continue
	[[ "$d" =~ "^No linguistic" ]] && continue
	
	locale=$c
	if [ "$locale" = "XX" ]; then
		locale=$b
	fi
	echo "%lang(${locale})	/usr/share/locale/${locale}" >> $RPM_BUILD_DIR/filelist
done
cat %{SOURCE1} | grep -v "^#" | grep -v "^$" | while read loc ; do
	locale=$loc
	locality=
	[[ "$locale" =~ "@" ]] && locale=${locale%%@*}
	[[ "$locale" =~ "_" ]] && locality=${locale##*_}

	# If the locality is not official, skip it
	if [ -n "$locality" ]; then
		grep -q "^$locality" /usr/share/iso-codes/iso_3166.tab || continue
	fi
	# If the locale is not official, skip it
	egrep -q "[[:space:]]${locale%_*}[[:space:]]" /usr/share/iso-codes/iso_639.tab || continue
	echo "%lang(${locale})	/usr/share/locale/${loc}" >> $RPM_BUILD_DIR/filelist
done


cat $RPM_BUILD_DIR/filelist | while read a b ; do
	mkdir -p -m 755 %{buildroot}/$b/LC_MESSAGES
done

%clean
rm -rf %{buildroot}

%files -f filelist
%defattr(0755,root,root)
%dir /
/bin
/boot
/dev
/etc
/home
/lib
%ifarch x86_64 ppc ppc64 sparc sparc64 s390 s390x
/%{_lib}
%endif
/media
%dir /mnt
%ghost %config(missingok) %verify(not size md5 mode user link rdev group mtime) /mnt/cdrom
%ghost %config(missingok) %verify(not size md5 mode user link rdev group mtime) /mnt/floppy
%dir /opt
%attr(555,root,root) /proc
%attr(750,root,root) /root
/sbin
/selinux
/srv
/sys
%attr(1777,root,root) /tmp
%dir /usr
/usr/[^s]*
/usr/sbin
%dir /usr/share
/usr/share/applications
/usr/share/desktop-directories
/usr/share/dict
/usr/share/doc
%attr(555,root,root) %dir /usr/share/empty
/usr/share/fonts
/usr/share/games
/usr/share/gnome
/usr/share/icons
/usr/share/info
%dir /usr/share/locale
/usr/share/man
/usr/share/mime-info
/usr/share/misc
/usr/share/omf
/usr/share/pixmaps
/usr/share/themes
/usr/share/xsessions
/usr/share/config-sample
/usr/src
%dir /var
/var/db
/var/games
/var/lib
/var/local
%dir %attr(0775,root,lock) /var/lock
%attr(755,root,root) /var/lock/subsys
/var/cache
/var/empty
/var/log
/var/mail
/var/nis
/var/opt
/var/preserve
/var/run
%dir /var/spool
%attr(755,root,root) /var/spool/lpd
%attr(775,root,mail) /var/spool/mail
%attr(1777,root,root) /var/tmp
/var/yp

%changelog
* Sun Apr 27 2008 Masahiro Takahata <takahata@momonga-linux.org>
- (2.4.13-1m)
- sync Fedora

* Thu Apr 03 2008 TABUCHI Takaaki <tab@momonga-linux.org>
- (2.4.6-3m)
- rebuild against gcc43

* Mon Jun 18 2007 Yohsuke Ooi <meke@momonga-linux.org>
- (2.4.6-2m)
- add /usr/share/theme

* Mon Jun 18 2007 Yohsuke Ooi <meke@momonga-linux.org>
- (2.4.6-1m)
- sync fedora

* Sun Feb 25 2007 Ichiro Nakai <ichiro@n.email.ne.jp>
- (2.3.7-3m)
- remove /usr/lib/locale, it's already provided by glibc-common

* Tue Mar 28 2006 Ryu SASAOKA <ryu@momonga-linux.org>
- (2.3.7-2m)
- revised installdir
- sync with fc-devel

* Tue Jan 10 2006 Masahiro Takahata <takahata@momonga-linux.org>
- (2.3.7-1m)
- sync with fc-devel

* Fri Feb 04 2005 TABUCHI Takaaki <tab@momonga-linux.org>
- (2.3.0-2m)
- readd /usr/share/config-sample
- /usr/X11R6/lib/X11, /usr/X11R6/lib/X11/app-defaults and /etc/X11/app-defaults
  is provided by xorg-x11-libs now

* Wed Jan 26 2005 Toru Hoshina <t@momonga-linux.org>
- (2.3.0-1m)
- import From FC3.

* Fri Sep 10 2004 Tsutomu Yasuda <tom@tom.homelinux.org>
- (2.2.4-2m)
  added /etc/X11/app-defaults and /usr/X11R6/lib/X11/app-defaults

* Thu Jul 29 2004 Masahiro Takahata <takahata@momonga-linux.org>
- (2.2.4-1m)
- upgrade and import from FC2

* Wed Nov  5 2003 Masaru SANUKI <sanuki@hh.iij4u.or.jp>
- (2.1.6-15m)
- use %%{momorel}

* Fri Jan 18 2002 Kazuhiko <kazuhiko@kondara.org>
- (2.1.6-14k)
- obey FHS (move /usr/dict to /usr/share/dict)

* Wed Nov 28 2001 Toru Hoshina <t@kondara.org>
- (2.1.6-12k)
- still need /var/ftp...

* Sat Nov 24 2001 Toru Hoshina <t@kondara.org>
- (2.1.6-10k)
- lock... is it owned by uucp, right?

* Tue Nov 13 2001 Shingo Akagaki <dora@kondara.org>
- (2.1.6-8k)
- nigittenu

* Sun Oct 28 2001 Toru Hoshina <t@kondara.org>
- (2.1.6-4k)
- lock...

* Mon Oct 22 2001 Toru Hoshina <t@kondara.org>
- (2.1.6-2k)
- merge from rawhide [filesystem-2.1.6-2].
- add /usr/share/config-sample for dotfiles.

* Mon Aug 20 2001 Bill Nottingham <notting@redhat.com>
- %%ghost /mnt/cdrom, /mnt/floppy (fixes #52046)

* Wed Aug 15 2001 Bill Nottingham <notting@redhat.com>
- add /usr/X11R6/share (#51830)

* Mon Aug 13 2001 Bill Nottingham <notting@redhat.com>
- prereq a particular version of the setup package

* Thu Aug  9 2001 Bill Nottingham <notting@redhat.com>
- remove /mnt/cdrom, /mnt/floppy (updfstab will create them if needed)
- make it noarch again

* Wed Aug  8 2001 Bill Nottingham <notting@redhat.com>
- /var/lock needs to be root.lock, not lock.lock

* Mon Aug  6 2001 Jeff Johnson <jbj@redhat.com>
- lock.lock ownership, 0775 permissions, for /var/lock.

* Tue Jul 17 2001 Bill Nottingham <notting@redhat.com>
- add /etc/sysconfig, /var/yp, /usr/share/pixmaps

* Tue Jul 10 2001 Bill Nottingham <notting@redhat.com>
- add stuff under /etc/X11
- remove extraneous /usr/X11R6/doc (#47490)

* Mon Jun 25 2001 Bill Nottingham <notting@redhat.com>
- don't conflict with rpm

* Fri Jun 22 2001 Bill Nottingham <notting@redhat.com>
- don't own /var/lib/rpm (#43315)
- add some stuff in /usr/local (#36522)

* Thu Jun 21 2001 Bill Nottingham <notting@redhat.com>
- add /initrd

* Thu Jun 07 2001 Florian La Roche <Florian.LaRoche@redhat.de>
- remove noarch
- do not include /mnt/cdrom and /mnt/floppy for s390/s390x

* Mon Apr 16 2001 Bill Nottingham <notting@redhat.com>
- take the group write off of /var/lock

* Fri Jul 21 2000 Bill Nottingham <notting@redhat.com>
- add /usr/share/empty

* Wed Jul 12 2000 Prospector <bugzilla@redhat.com>
- automatic rebuild

* Wed Jun 28 2000 Preston Brown <pbrown@redhat.com>
- remove /usr/doc

* Thu Jun 22 2000 Preston Brown <pbrown@redhat.com>
- remove /usr/info

* Sun Jun 19 2000 Bill Nottingham <notting@redhat.com>
- remove /usr/man

* Sat Jun 17 2000 Bill Nottingham <notting@redhat.com>
- /var/spool/lpd should have normal perms (#12272)

* Tue Jun  6 2000 Bill Nottingham <notting@redhat.com>
- add /etc/skel

* Thu Jun 01 2000 Preston Brown <pbrown@redhat.com>
- add /var/spool/lpd to filesystem, owned by user/group lp, tight permissions

* Tue May 23 2000 Trond Eivind Glomsr?<teg@redhat.com>
- Added /etc/xinetd.d

* Mon May 15 2000 Preston Brown <pbrown@redhat.com>
- /etc/opt, /usr/share/{info,man/man*,misc,doc} (FHS 2.1)
- added /var/games.  Data should move from /var/lib/games to there (FHS 2.1)
- bump version up to 2.0 already!

* Thu Apr 13 2000 Jakub Jelinek <jakub@redhat.com>
- removed /var/state, added /var/opt, /var/mail for FHS 2.1 compliance

* Mon Aug 28 1999 Preston Brown <pbrown@redhat.com>
- added /opt, /var/state, /var/cache for FHS compliance (#3966)

* Sun Mar 21 1999 Cristian Gafton <gafton@redhat.com> 
- auto rebuild in the new build environment (release 4)

* Sun Jan 17 1999 Jeff Johnson <jbj@redhat.com>
- don't carry X11R6.1 as directory on sparc.
- /var/tmp/build root (#811)

* Wed Jan 13 1999 Preston Brown <pbrown@redhat.com>
- font directory didn't belong, which I previously misunderstood.  removed.

* Fri Nov 13 1998 Preston Brown <pbrown@redhat.com>
- /usr/share/fonts/default added.

* Fri Oct  9 1998 Bill Nottingham <notting@redhat.com>
- put /mnt/cdrom back in

* Wed Oct  7 1998 Bill Nottingham <notting@redhat.com>
- Changed /root to 0750

* Wed Aug 05 1998 Erik Troan <ewt@redhat.com>
- added /var/db
- set attributes in the spec file; don't depend on the ones in the cpio
  archive
- use a tarball instead of a cpioball

* Mon Apr 27 1998 Prospector System <bugs@redhat.com>
- translations modified for de, fr, tr

* Tue Sep 09 1997 Erik Troan <ewt@redhat.com>
- made a noarch package

* Wed Jul 09 1997 Erik Troan <ewt@redhat.com>
- added /

* Wed Apr 16 1997 Erik Troan <ewt@redhat.com>
- Changed /proc to 555
- Removed /var/spool/mqueue (which is owned by sendmail)
